"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// Constructors
var createStandardAction = function (type) {
    var ctor = function (payload) { return ({ type: type, payload: payload }); };
    ctor.type = type;
    return function () { return ctor; };
};
exports.createStandardAction = createStandardAction;
// Redux
// helper to use in switch-case
var getType = function (actionCtor) { return actionCtor.type; };
exports.getType = getType;
// Effects
// helper for pipe filtering in effects
var isActionOf = function (actionCtors) {
    return function (action) {
        return actionCtors.some(function (ctor) { return ctor.type === action.type; });
    };
};
exports.isActionOf = isActionOf;
