"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
exports.combineReducers = function (reducers, initialState) {
    var entries = Object.entries(reducers);
    var initialStateSafe = initialState != null
        ? initialState
        : Object.create(null);
    return function (action, state) {
        if (state === void 0) { state = initialStateSafe; }
        // shallow check if store branch was updated
        var shouldUpdate = false;
        var newState = entries.reduce(
        // [any, any] TS hack
        function (acc, _a) {
            var _b = tslib_1.__read(_a, 2), key = _b[0], fn = _b[1];
            acc[key] = fn(action, state[key] || void 0);
            if (acc[key] !== state[key]) {
                shouldUpdate = true;
            }
            return acc;
        }, Object.create(null));
        return shouldUpdate
            ? newState
            : state;
    };
};
