"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
;
var INIT_STORE_ACTION = { type: 'INIT_STORE' };
exports.INIT_STORE_ACTION = INIT_STORE_ACTION;
// }}}
var createStore = function (reducersRoot, effectsRoot) {
    var actions$ = new rxjs_1.Subject();
    var state$ = new rxjs_1.ReplaySubject(1);
    var destroy$ = new rxjs_1.Subject();
    // reducers
    actions$.pipe(operators_1.withLatestFrom(state$.pipe(operators_1.startWith(void 0))), operators_1.map(function (_a) {
        var _b = tslib_1.__read(_a, 2), action = _b[0], state = _b[1];
        return reducersRoot(action, state);
    }), operators_1.distinctUntilChanged(), suppressAndLogError('[redogs:store]'), operators_1.takeUntil(destroy$)).subscribe(state$);
    // effects
    if (typeof effectsRoot == 'function') {
        effectsRoot(actions$, state$).pipe(suppressAndLogError('[redogs:effects]'), operators_1.takeUntil(destroy$))
            .subscribe(actions$);
    }
    // init store
    actions$
        .next(INIT_STORE_ACTION);
    return {
        state$: state$.asObservable(),
        dispatch: function (action) {
            actions$.next(action);
        },
        destroy$: destroy$
    };
};
exports.createStore = createStore;
// Helpers
function suppressAndLogError(msgPrefix) {
    return rxjs_1.pipe(operators_1.catchError(function (err) {
        // NOTE: basically, we're suppressing errors here
        if (console && typeof console.error == 'function') {
            console.error(msgPrefix, err);
        }
        return rxjs_1.EMPTY;
    }));
}
