// Constructors
const createStandardAction = (type) => {
    const ctor = (payload) => ({ type, payload });
    ctor.type = type;
    return () => ctor;
};
// Redux
// helper to use in switch-case
const getType = (actionCtor) => actionCtor.type;
// Effects
// helper for pipe filtering in effects
const isActionOf = (actionCtors) => {
    return (action) => actionCtors.some(ctor => ctor.type === action.type);
};
export { createStandardAction, getType, isActionOf };
