export const combineReducers = (reducers, initialState) => {
    const entries = Object.entries(reducers);
    const initialStateSafe = initialState != null
        ? initialState
        : Object.create(null);
    return (action, state = initialStateSafe) => {
        // shallow check if store branch was updated
        let shouldUpdate = false;
        const newState = entries.reduce(
        // [any, any] TS hack
        (acc, [key, fn]) => {
            acc[key] = fn(action, state[key] || void 0);
            if (acc[key] !== state[key]) {
                shouldUpdate = true;
            }
            return acc;
        }, Object.create(null));
        return shouldUpdate
            ? newState
            : state;
    };
};
