// Constructors
var createStandardAction = function (type) {
    var ctor = function (payload) { return ({ type: type, payload: payload }); };
    ctor.type = type;
    return function () { return ctor; };
};
// Redux
// helper to use in switch-case
var getType = function (actionCtor) { return actionCtor.type; };
// Effects
// helper for pipe filtering in effects
var isActionOf = function (actionCtors) {
    return function (action) {
        return actionCtors.some(function (ctor) { return ctor.type === action.type; });
    };
};
export { createStandardAction, getType, isActionOf };
