interface IAction<T extends string, P> {
    type: T;
    payload?: P;
}
interface ActionCreator<T extends string, P> {
    type: T;
    (payload: P): IAction<T, P>;
}
declare const createStandardAction: <T extends string>(type: T) => <P = void>() => ActionCreator<T, P>;
declare const getType: <T extends string>(actionCtor: ActionCreator<T, unknown>) => T;
declare const isActionOf: <S extends string, T extends ActionCreator<S, unknown>>(actionCtors: T[]) => (action: IAction<S, unknown>) => action is ReturnType<T>;
export { IAction, ActionCreator };
export { createStandardAction, getType, isActionOf };
//# sourceMappingURL=actions.d.ts.map