import { Observable, Subject } from 'rxjs';
interface IAction {
    type: string;
    payload?: any;
}
declare const INIT_STORE_ACTION: IAction;
interface IEffect<S = unknown> {
    (actions$: Observable<IAction>, store$: Observable<S>): Observable<IAction>;
}
interface IReducer<S = unknown> {
    (action: IAction, state: S): S;
}
declare const createStore: <S>(reducersRoot: IReducer<S>, effectsRoot?: IEffect<S>) => {
    state$: Observable<S>;
    dispatch(action: any): void;
    destroy$: Subject<void>;
};
export { IReducer, IEffect };
export { INIT_STORE_ACTION, createStore };
//# sourceMappingURL=store.d.ts.map